# These macros will go away soon. Hopefully.
%global _openmpi_load \
 . /etc/profile.d/modules.sh; \
 module load openmpi-%{_arch}; \
 export CFLAGS="$CFLAGS %{optflags}";
%global _openmpi_unload \
 . /etc/profile.d/modules.sh; \
 module unload openmpi-%{_arch};

%global	_lam_load \
 . /etc/profile.d/modules.sh; \
 module load lam-%{_arch}; \
 export CFLAGS="$CFLAGS %{optflags}";
%global _lam_unload \
 . /etc/profile.d/modules.sh; \
 module unload lam-%{_arch};

%global _mpich2_load \
 . /etc/profile.d/modules.sh; \
 module load mpich2-%{__isa_bits}; \
 export CFLAGS="$CFLAGS %{optflags}";
%global _mpich2_unload \
 . /etc/profile.d/modules.sh; \
 module unload mpich2-%{__isa_bits};

Summary: Basic Linear Algebra Communication Subprograms
Name: blacs
Version: 1.1
Release: 33%{?dist}
License: Public Domain
Group: Development/Libraries
URL: http://www.netlib.org/blacs
Source0: http://www.netlib.org/blacs/mpiblacs.tgz
Source1: Bmake.inc
Source2: http://www.netlib.org/blacs/mpi_prop.ps
Source3: http://www.netlib.org/blacs/blacs_install.ps
Source4: http://www.netlib.org/blacs/mpiblacs_issues.ps
Source5: http://www.netlib.org/blacs/f77blacsqref.ps
Source6: http://www.netlib.org/blacs/cblacsqref.ps
Source7: http://www.netlib.org/blacs/lawn94.ps
BuildRequires: gcc-gfortran
BuildRequires: lapack, blas
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Patch0: blacs-fedora.patch

%description
The BLACS (Basic Linear Algebra Communication Subprograms) project is 
an ongoing investigation whose purpose is to create a linear algebra 
oriented message passing interface that may be implemented efficiently 
and uniformly across a large range of distributed memory platforms.

The length of time required to implement efficient distributed memory 
algorithms makes it impractical to rewrite programs for every new 
parallel machine. The BLACS exist in order to make linear algebra 
applications both easier to program and more portable. 

%package common
Summary: Common files for blacs
Group: Development/Libraries
Requires: lapack, blas

%description common
The BLACS (Basic Linear Algebra Communication Subprograms) project is
an ongoing investigation whose purpose is to create a linear algebra
oriented message passing interface that may be implemented efficiently
and uniformly across a large range of distributed memory platforms.

The length of time required to implement efficient distributed memory
algorithms makes it impractical to rewrite programs for every new
parallel machine. The BLACS exist in order to make linear algebra
applications both easier to program and more portable.

This file contains common files which are not specific to any MPI implementation.

%package lam
Summary: BLACS libraries compiled against lam
Group: Development/Libraries
BuildRequires: lam-devel
Requires: %{name}-common = %{version}-%{release}
Requires: environment-modules

%description lam
The BLACS (Basic Linear Algebra Communication Subprograms) project is
an ongoing investigation whose purpose is to create a linear algebra
oriented message passing interface that may be implemented efficiently
and uniformly across a large range of distributed memory platforms.

The length of time required to implement efficient distributed memory
algorithms makes it impractical to rewrite programs for every new
parallel machine. The BLACS exist in order to make linear algebra
applications both easier to program and more portable.

This package contains BLACS libraries compiled with lam.

%package lam-devel
Summary: Development libraries for blacs (lam)
Group: Development/Libraries
Requires: %{name}-lam = %{version}-%{release}
Provides: %{name}-lam-static = %{version}-%{release}

%description lam-devel
This package contains development libraries for blacs, compiled	against lam.

%package mpich2
Summary: BLACS libraries compiled against mpich2
Group: Development/Libraries
BuildRequires: mpich2-devel
Requires: %{name}-common = %{version}-%{release}
Requires: environment-modules

%description mpich2
The BLACS (Basic Linear Algebra Communication Subprograms) project is
an ongoing investigation whose purpose is to create a linear algebra
oriented message passing interface that may be implemented efficiently
and uniformly across a large range of distributed memory platforms.

The length of time required to implement efficient distributed memory
algorithms makes it impractical to rewrite programs for every new
parallel machine. The BLACS exist in order to make linear algebra
applications both easier to program and more portable.

This package contains BLACS libraries compiled with mpich2.

%package mpich2-devel
Summary: Development libraries for blacs (mpich2)
Group: Development/Libraries
Requires: %{name}-mpich2 = %{version}-%{release}
Provides: %{name}-mpich2-static = %{version}-%{release}

%description mpich2-devel
This package contains development libraries for blacs, compiled against mpich2.

%package openmpi
Summary: BLACS libraries compiled against openmpi
Group: Development/Libraries
Requires: %{name}-common = %{version}-%{release}
Requires: environment-modules

%description openmpi
The BLACS (Basic Linear Algebra Communication Subprograms) project is
an ongoing investigation whose purpose is to create a linear algebra
oriented message passing interface that may be implemented efficiently
and uniformly across a large range of distributed memory platforms.

The length of time required to implement efficient distributed memory
algorithms makes it impractical to rewrite programs for every new
parallel machine. The BLACS exist in order to make linear algebra
applications both easier to program and more portable.

This package contains BLACS libraries compiled with openmpi.

%package openmpi-devel
Summary: Development libraries for blacs (openmpi)
Group: Development/Libraries
BuildRequires: openmpi-devel
Requires: %{name}-openmpi = %{version}-%{release}
Provides: %{name}-openmpi-static = %{version}-%{release}

%description openmpi-devel
This package contains development libraries for blacs, compiled	against openmpi.

%prep
%setup -q -c -n %{name}
%patch0 -p1
for i in lam mpich2 openmpi; do
	cp -a BLACS BLACS-$i
	cp -f %{SOURCE1} BLACS-$i/
	sed -i "s|FOO|$i|g" BLACS-$i/Bmake.inc
done

# copy in docs:
cp %{SOURCE2} mpi_prop.ps
cp %{SOURCE3} blacs_install.ps
cp %{SOURCE4} mpiblacs_issues.ps
cp %{SOURCE5} f77blacsqref.ps
cp %{SOURCE6} cblacsqref.ps
cp %{SOURCE7} lawn94.ps

%build
# CFLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-fstack-protector//g'`
# RPM_OPT_FLAGS=`echo $CFLAGS`

# To avoid replicated code define a build macro
%define dobuild() \
cd BLACS-$MPI_COMPILER; \
make mpi ; \
cd ..

# Build LAM version
export MPI_COMPILER=lam
%{_lam_load}
RPM_OPT_FLAGS=`echo $CFLAGS`
%dobuild
%{_lam_unload}

# Build mpich2 version
export MPI_COMPILER=mpich2
%{_mpich2_load}
RPM_OPT_FLAGS=`echo $CFLAGS`
%dobuild
%{_mpich2_unload}

# Build OpenMPI version
export MPI_COMPILER=openmpi
%{_openmpi_load}
RPM_OPT_FLAGS=`echo $CFLAGS`
%dobuild
%{_openmpi_unload}

# cd TESTING/
# make
# cd ../..

%install
# mkdir -p ${RPM_BUILD_ROOT}%{_bindir}

for i in lam mpich2 openmpi; do 
  mkdir -p %{buildroot}%{_libdir}/blacs-$i/
  pushd BLACS-$i/LIB
  for f in *.a *.so*; do
    cp -f $f %{buildroot}%{_libdir}/blacs-$i/$f
  done
  popd
  pushd %{buildroot}%{_libdir}/blacs-$i/
  for l in libmpiblacs libmpiblacsF77init libmpiblacsCinit; do
    ln -fs $l.so.1.0.0 $l.so.1
    ln -s $l.so.1.0.0 $l.so
  done
  popd
# Generate environment module file
mkdir -p %{buildroot}%{_datadir}/Modules/modulefiles/
cat << EOF > %{buildroot}%{_datadir}/Modules/modulefiles/blacs-$i-%{_arch}
#%Module 1.0
#
#  Blacs libraries compiled with $i support
#
prepend-path		LD_LIBRARY_PATH		%{_libdir}/blacs-$i
setenv			LDFLAGS			-L%{_libdir}/blacs-$i
EOF
done

# cd ../TESTING/EXE
# cp -f x*test_MPI-LINUX-0 ${RPM_BUILD_ROOT}%{_bindir}

%clean
rm -fr ${RPM_BUILD_ROOT}

%files common
%defattr(-,root,root,0755)
%doc mpi_prop.ps blacs_install.ps mpiblacs_issues.ps f77blacsqref.ps cblacsqref.ps lawn94.ps
# %{_bindir}/x*test_MPI-LINUX-0

%files lam
%defattr(-,root,root,0755)
%dir %{_libdir}/blacs-lam/
%{_datadir}/Modules/modulefiles/blacs-lam-%{_arch}
%{_libdir}/blacs-lam/*.so.*

%files lam-devel
%defattr(-,root,root,0755)
%{_libdir}/blacs-lam/*.a
%{_libdir}/blacs-lam/*.so

%files mpich2
%defattr(-,root,root,0755)
%dir %{_libdir}/blacs-mpich2/
%{_datadir}/Modules/modulefiles/blacs-mpich2-%{_arch}
%{_libdir}/blacs-mpich2/*.so.*

%files mpich2-devel
%defattr(-,root,root,0755)
%{_libdir}/blacs-mpich2/*.a
%{_libdir}/blacs-mpich2/*.so

%files openmpi
%defattr(-,root,root,0755)
%dir %{_libdir}/blacs-openmpi/
%{_datadir}/Modules/modulefiles/blacs-openmpi-%{_arch}
%{_libdir}/blacs-openmpi/*.so.*

%files openmpi-devel
%defattr(-,root,root,0755)
%{_libdir}/blacs-openmpi/*.a
%{_libdir}/blacs-openmpi/*.so

%changelog
* Thu Aug  6 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 1.1-33
- rework package to handle all supported MPI environments in Fedora

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1-32
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Mon Feb 23 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1-31
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Sep 23 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.1-30
- incorporate Deji Akingunola's changes
- use openmpi rather than lam

* Tue Jul  8 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.1-29
- fix lam paths

* Tue Jul  8 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.1-28
- rebuild

* Tue May 13 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.1-27
- ia64 doesn't use /usr/lib64

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 1.1-26.1
- Autorebuild for GCC 4.3

* Thu Aug 23 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-25.1
- fix shared patch in devel

* Thu Aug 23 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-25
- rebuild for BuildID

* Wed Dec 20 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-24.1
- updated bmake files to include new lam-devel header path

* Mon Sep 11 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-24
- FC-5+ needs lam-devel as a BR

* Mon Sep 11 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-23
- bump for FC-6

* Fri Apr  7 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-22
- FC-5+ also needs -L libdir/lam

* Fri Apr  7 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-21
- FC-5+ needs includedir/lam

* Fri Apr  7 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-20
- fix lam BR

* Tue Feb 28 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-19
- fix broken bits in shared lib (no -fstack-protector for us)

* Mon Dec 19 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-18
- rebuild for gcc4.1

* Sun Jul 31 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-17
- fix g77 for FC-3 spec

* Fri Jul 29 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-16
- remove ppc hack

* Fri Jul 29 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-15
- Fix typo in fix. :/

* Fri Jul 29 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-12
- fix INTFACE for FC-4+

* Fri Jul 29 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-11
- bump for new tag

* Mon Jun 27 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-10
- split static lib and .so into -devel package
- fix Bmake files for shared library support
- build shared libraries

* Tue May 10 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-8
- g77 needs some special compile flags, edited Bmake.inc*

* Mon May  9 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-7
- remove hardcoded dist tags

* Thu May  5 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-6
- fix 64bit issues

* Sun Apr 24 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-5
- use dist tag
- fix fc3 package sources and dependencies

* Tue Apr 19 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-4
- fix buildroot
- add gcc-gfortran as a BuildRequires (gcc-g77)

* Mon Apr 18 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-3
- backout shared patch

* Mon Apr 18 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-2
- rename libs to what scalapack thinks they should be called

* Mon Apr 18 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-1
- initial package creation
